//#include "config.h"
#include <X11/Xlib.h>
#include <X11/extensions/XShm.h>
#include <X11/Xutil.h>
#include <X11/extensions/shape.h>
#include <X11/Xatom.h>
#include <X11/Xos.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <math.h>
#include <X11/Xatom.h>
#include <X11/cursorfont.h>
#include <X11/Xmu/WinUtil.h>
#include <glib-2.0/glib.h>

// g++ -o ./iconrun1 ./iconrun1.c  -lImlib2 -lX11 -lXmu `pkg-config --cflags --libs glib-2.0`

/*
#include <sys/time.h>
#include "common.h"
#include "image.h"
#include "rend.h"
#include "rgba.h"
#include "ximage.h"
#include "color.h"
 */
#include "Imlib2.h"

Display            *disp;
Window              win;
Window              win2;
Window              win3;
Visual             *vis;
Colormap            cm;
int                 depth;
XSetWindowAttributes attr;
char *appToRun;
int mytoggle = 0;
Imlib_Image         buffer3;
Imlib_Font          font3;


#include "./other_src/wm_ctrl.c"

int ReplaceStr(char *sSrc, char *sMatchStr, char *sReplaceStr)
{
   int  StringLen;
   char caNewString[1024];
   char *FindPos = strstr(sSrc, sMatchStr);
   if( (!FindPos) || (!sMatchStr) )
      return -1;
   while( FindPos )
   {
      memset(caNewString, 0, sizeof(caNewString));
      StringLen = FindPos - sSrc;
      strncpy(caNewString, sSrc, StringLen);
      strcat(caNewString, sReplaceStr);
      strcat(caNewString, FindPos + strlen(sMatchStr));
      strcpy(sSrc, caNewString);
      FindPos = strstr(sSrc, sMatchStr);
   }

   return 0;
}

/* nothing fancy */
int trans(double d, Window target_win)
{
  #define OPAQUE	0xffffffff
  #define OPACITY	"_NET_WM_WINDOW_OPACITY"
  unsigned int opacity;

  opacity = (unsigned int) (d * OPAQUE);
  XChangeProperty(disp, target_win, XInternAtom(disp, OPACITY, False), 
		    XA_CARDINAL, 32, PropModeReplace, 
		    (unsigned char *) &opacity, 1L);
  XSync(disp, False);
  return 0;
}


void init_window(int win_id)
{

  unsigned long action;
  gchar *tmp_prop2, *tmp2;
  gchar *tmp_prop1, *tmp1;
  char *p1="maximized_vert", *p2="maximized_horz";
  Atom prop1 = 0;
  Atom prop2 = 0;
  action = _NET_WM_STATE_REMOVE;
  tmp_prop2 = g_strdup_printf("_NET_WM_STATE_%s", tmp2 = g_ascii_strup(p2, -1));
  p_verbose("State 2: %s\n", tmp_prop2); 
  prop2 = XInternAtom(disp, tmp_prop2, False);
  tmp_prop1 = g_strdup_printf("_NET_WM_STATE_%s", tmp1 = g_ascii_strup(p1, -1));
  p_verbose("State 1: %s\n", tmp_prop1); 
  prop1 = XInternAtom(disp, tmp_prop1, False);
  client_msg(disp, win_id, "_NET_WM_STATE", 
    action, (unsigned long)prop1, (unsigned long)prop2, 0, 0);
  p1="fullscreen";
  p2="above";
  prop1 = 0;
  prop2 = 0;
  action = _NET_WM_STATE_REMOVE;
  tmp_prop2 = g_strdup_printf("_NET_WM_STATE_%s", tmp2 = g_ascii_strup(p2, -1));
  p_verbose("State 2: %s\n", tmp_prop2); 
  prop2 = XInternAtom(disp, tmp_prop2, False);
  tmp_prop1 = g_strdup_printf("_NET_WM_STATE_%s", tmp1 = g_ascii_strup(p1, -1));
  p_verbose("State 1: %s\n", tmp_prop1); 
  prop1 = XInternAtom(disp, tmp_prop1, False);
  client_msg(disp, win_id, "_NET_WM_STATE", 
      action, (unsigned long)prop1, (unsigned long)prop2, 0, 0);
}

int main(int argc, char **argv)
{
  int                 w, h, x, y;
  Imlib_Image         im_bg = NULL;
  XEvent              ev;
  const char         *display_name = getenv("DISPLAY");
  Imlib_Image         buffer;
  Imlib_Image         back;
  Imlib_Image         bigback;
  Imlib_Font          font;
  char                text[1024];
  char                *skip;
  Imlib_Color_Range   range;
  if (display_name == NULL)
    display_name = ":0";
  disp = XOpenDisplay(display_name);
  if (disp == NULL)
  {
    fprintf(stderr, "Can't open display %s\n", display_name);
    return 1;
  }

  int screen=DefaultScreen(disp);
  int screenWidth=0;
  screenWidth=XDisplayWidth(disp,screen);
  screenWidth=64;
  int screenHeight;
  screenHeight=64;
  int screenX=10;
  int screenY=10;
  int lowerraise=0;
  char group[1024];
  char picname[1024];
  int xl=0;
  int yl=0;
  int store=0;
  int autohidemainbutton=0;
  int MouseMoveOpenSubIcon=0;
  char submenue[1000];
  char *win_move;
  int bord=0;
  char home[1024];
  sprintf(home,"%s",getenv("HOME"));
  int show_sys_inf=0;
  double trans_icon=0.65;
//  double trans_wind=0.85;
  if ( home == "" )
  {
    printf("fatal error: no /home/xxx found!\n");
    return 1;
  }

//----arguments x y width height lower/raise(0/1) picture hidemode
  if ( argc != 15 )
  {
    printf("usage: iconrun1 x y width height lower/raise(0/1) group image autohidemainbutton(0/1/2) MouseMoveOpenSubIcon(0/1/2) windows_class_for_skip win_move_where bord(0/1) show_system_infomation(0/1) trans_icon \n");
    return 1;
  }
 // printf("ok\n");
  sscanf(argv[1], "%d", &screenX);
  sscanf(argv[2], "%d", &screenY);
  sscanf(argv[3], "%d", &screenWidth);
  sscanf(argv[4], "%d", &screenHeight);
  sscanf(argv[5], "%d", &lowerraise);
  sscanf(argv[6], "%s", &group);
  sscanf(argv[7], "%s", &picname);
  sscanf(argv[8], "%d", &autohidemainbutton);
  sscanf(argv[9], "%d", &MouseMoveOpenSubIcon);
  skip=argv[10];
  win_move=argv[11];
  sscanf(argv[12], "%d", &bord);
  sscanf(argv[13], "%d", &show_sys_inf);
  trans_icon = atof (argv[14]);
//  trans_wind = atof (argv[15]);
  
  vis = DefaultVisual(disp, DefaultScreen(disp));
  depth = DefaultDepth(disp, DefaultScreen(disp));
  cm = DefaultColormap(disp, DefaultScreen(disp));
        // text
  range = imlib_create_color_range();
  imlib_context_set_color_range(range);
  imlib_context_set_color(255, 255, 255, 255);
  imlib_add_color_to_color_range(0);
  /* add an orange color, semi-transparent 10 units from the first */
  imlib_context_set_color(255, 200, 10, 255);
  imlib_add_color_to_color_range(10);
  /* add black, fully transparent at the end 20 units away */
  imlib_context_set_color(70, 0, 0, 255);
  imlib_add_color_to_color_range(20);

  attr.override_redirect=True;
 //win=XCreateWindow(disp,DefaultRootWindow(disp),screenX,screenY,screenWidth,screenHeight,0,CopyFromParent,InputOutput,CopyFromParent,CWBackingStore|CWOverrideRedirect|CWEventMask|CWBorderPixel|CWSaveUnder|CWColormap|CWBackPixel,&attr);
  win=XCreateWindow(disp,DefaultRootWindow(disp),screenX,screenY,screenWidth,screenHeight,0,0,0,CopyFromParent,CWBackingStore|CWOverrideRedirect|CWEventMask,&attr);
//   win =  XCreateSimpleWindow(disp, DefaultRootWindow(disp), 0, 0, 100, 100, 0, 0, 0);
  XSelectInput(disp, win, ButtonPressMask | ButtonReleaseMask | ButtonMotionMask | PointerMotionMask | ExposureMask | EnterWindowMask | LeaveWindowMask);
  XMapWindow(disp, win);

  if(lowerraise==0)
     XLowerWindow(disp,win);
  if(lowerraise==1)
     XRaiseWindow(disp,win);
  trans(trans_icon,win);
   /**
    * Start rendering
    */

  imlib_context_set_display(disp);
  imlib_context_set_visual(vis);
  imlib_context_set_colormap(cm);
  imlib_context_set_drawable(win);
  imlib_context_set_dither(1);
  imlib_context_set_blend(0);
  imlib_context_set_color_modifier(NULL);

//--
  w=screenWidth;
  h=screenHeight;
  char back_pic[1280];
  sprintf(back_pic,"%s/.icon-DE/pics/background.png",home);
  if (access(back_pic,0)==-1)
    sprintf(back_pic,"/usr/share/icon-DE/pics/background.png");
  back = imlib_load_image(back_pic);
  imlib_context_set_image(back);
  buffer = imlib_create_cropped_scaled_image(0, 0,imlib_image_get_width() ,imlib_image_get_height() , w , h);
  im_bg = imlib_load_image(picname);
  XMapWindow(disp, win);
  imlib_context_set_image(im_bg);

  int is=imlib_image_get_width();
  int ih=imlib_image_get_height();
  int d1=screenWidth-is;
  d1=d1/2;
  int d2=screenHeight-ih;
  d2=d2/2;
  int i=0;
  imlib_context_set_image(im_bg);
  imlib_context_set_blend(1);

  imlib_context_set_image(back);
  imlib_render_image_on_drawable(0, 0);
  imlib_context_set_image(im_bg);
  imlib_render_image_on_drawable_at_size(d1-1, d2-1,is+2,ih+2);
  bigback=imlib_create_image_from_drawable( 0,0,0,w,h,1);

  imlib_context_set_image(back);
  imlib_render_image_on_drawable(0, 0);
  imlib_context_set_image(im_bg);

  imlib_render_image_on_drawable(d1, d2);
  back=imlib_create_image_from_drawable( 0,0,0,w,h,1);

  char font_path[1024];
  sprintf(font_path,"%s/.icon-DE/fonts",home);
  imlib_add_path_to_font_path(font_path);
  imlib_add_path_to_font_path("/usr/share/fonts/truetype/wqy/");
  //wqy-zenhei.ttc
  XResizeWindow(disp, win, w, h);
  XSync(disp, False);
  if (autohidemainbutton==1)
     XMoveWindow(disp,win,-screenWidth+2 , screenY);
  if (autohidemainbutton==2)
     XMoveWindow(disp,win,-screenWidth/2 , screenY);
  x = -9999;
  y = -9999;
  x = -screenWidth/2;
  y = -screenHeight/2;

  while (1)
  {
    do
    {
      XNextEvent(disp, &ev);
      switch (ev.type)
      {
      case Expose:
        break;
      case MotionNotify:
        x = ev.xmotion.x;
        y = ev.xmotion.y;
      default:
        break;
      case EnterNotify:		
        if(lowerraise==0)
           XLowerWindow(disp,win);
        if(lowerraise==1)
           XRaiseWindow(disp,win);
        if (show_sys_inf==1)
        {
          mytoggle = 1;
          buffer = imlib_create_image(500, 220);  
          font = imlib_load_font("Vera/10");
          if (font == NULL)
            font = imlib_load_font("wqy-zenhei.ttc/10");
          imlib_context_set_font(font);
          imlib_context_set_color(0, 0, 0, 255);
          win2=XCreateWindow(disp,DefaultRootWindow(disp),screenX+screenWidth+4,screenY,500,220,0,0,0,CopyFromParent,CWBackingStore|CWOverrideRedirect|CWEventMask,&attr);
          XRaiseWindow(disp,win2);
          XMapWindow(disp, win2);
          imlib_context_set_drawable(win2); 
//          imlib_context_set_image(buffer);
          imlib_context_set_image(buffer);
          imlib_image_fill_color_range_rectangle(0,0, 1000, 440,-5.0);
//          imlib_free_color_range();
          imlib_context_set_image(buffer);
          imlib_render_image_on_drawable(0, 0); 
          imlib_context_set_image(buffer);
          imlib_context_set_font(font);
          imlib_context_set_color(0, 0, 0, 255);

          time_t now_time;
          now_time=time(0);
          strftime(text, sizeof(text), "%Y年%m月%d日 星期(%w)",localtime(&now_time) );
          imlib_text_draw(60,2,text);
          if (list_windows(disp,skip)!=EXIT_FAILURE)
            sprintf(text," 有（ %d ）个打开的窗口",win_count);
          imlib_text_draw(240,2,text);
          imlib_context_set_font(font);
          imlib_free_font();
          font = imlib_load_font("Vera/9");
          if (font == NULL)
            font = imlib_load_font("wqy-zenhei.ttc/9");
          imlib_context_set_font(font);
          sprintf(back_pic,"top -b -n1 >%s/top.txt",home);
          system(back_pic);
          FILE *freeNum;
          sprintf(back_pic,"%s/top.txt",home);
          freeNum=fopen(back_pic,"r");
          if ( freeNum==NULL)
            printf("error on open top.txt\n"); 
          fgets(text,1024,freeNum);
          i=1;
          while (! feof(freeNum))
          {
            if (i<8)  
            {
              ReplaceStr(text,"top -","时间：");
              ReplaceStr(text,"up ",", 已开机：");
              ReplaceStr(text," users"," 个用户");
              ReplaceStr(text," user"," 个用户");
              ReplaceStr(text,"load average:","系统负载：");
              ReplaceStr(text,"Tasks:","进程：");
              ReplaceStr(text,"total","总数中");
              ReplaceStr(text,"running","个正运行");
              ReplaceStr(text,"sleeping","个在休眠");
              ReplaceStr(text,"stopped","个已停止");
              ReplaceStr(text,"zombie","个已僵死");
              ReplaceStr(text,"Mem:","内存：");
              ReplaceStr(text,"total","总数中");
              ReplaceStr(text,"used","已使用");
              ReplaceStr(text,"free","空闲");
              ReplaceStr(text,"buffers","缓冲");
              ReplaceStr(text,"Swap:","交换内存：");
              ReplaceStr(text,"cached","缓存");
              ReplaceStr(text,"us"," 用户");
              ReplaceStr(text,"sy"," 系统");
              ReplaceStr(text,"id"," 空闲");
              ReplaceStr(text,"wa"," 等待");
              ReplaceStr(text,"ni"," 优先");
              ReplaceStr(text,",  0.0%hi","");
              ReplaceStr(text,",  0.0%si","");
              ReplaceStr(text,",  0.0%st","");
            }
            imlib_text_draw(5,i*15+8,text);
            i=i+1;
            fgets(text,1024,freeNum);
            
          } 
          imlib_context_set_image(buffer);
          imlib_context_set_drawable(win2); 
          imlib_render_image_on_drawable(0, 0); 
          imlib_context_set_image(buffer);
          imlib_free_image();
          imlib_context_set_font(font);
          imlib_free_font();
          imlib_context_set_image(im_bg);
          imlib_context_set_drawable(win);
          
          fclose(freeNum); 
        }  

        XMoveWindow(disp,win,screenX , screenY);
        system("killall iconrun3 2>/dev/null");	
        if ((store==0) and (MouseMoveOpenSubIcon==2))
        {
          sprintf(submenue,"icon-wharf START %d",bord);
          system(submenue);
          store=1;
        }
        if (MouseMoveOpenSubIcon==1)
        {
          system("killall iconrun2 2>/dev/null");
          sprintf(submenue,"icon-wharf START %d",bord);
          system(submenue);
        }
        break;
      case LeaveNotify:		
        x = -screenWidth/2;
        y = -screenHeight/2;
        if ( get_active_window(disp)!=0 )
        {
          init_window(get_active_window(disp));
          window_move_resize(disp,get_active_window(disp),win_move);
        }  
        if (show_sys_inf==1)
        {
          mytoggle = 0;
          XDestroyWindow(disp,win2);	
        }  
        if(autohidemainbutton==1)
          XMoveWindow(disp,win,-screenWidth+2 , screenY);
        if(autohidemainbutton==2)
          XMoveWindow(disp,win,-screenWidth/2 , screenY);
        break;
      case ButtonPress:				
        if(ev.xbutton.button==1)
        {
          if((store==1) and (MouseMoveOpenSubIcon==0))
          {
            system("killall iconrun2 2>/dev/null");	
            system("killall iconrun3 2>/dev/null");	
            store=0;
            break;
          } else {
            sprintf(submenue,"icon-wharf START %d ",bord);
            system(submenue);
            store=1;
          }  
        }
        if(ev.xbutton.button==2)
        {
          if (get_active_window(disp)!=0)
            close_window(disp,get_active_window(disp));
          break;
        }
        if(ev.xbutton.button==3)
        {
                        /* if we click anywhere in the window, exit */
          system("killall iconrun3 2>/dev/null");	
          system("killall iconrun2 2>/dev/null");	
          system("killall iconclock 2>/dev/null");	
          sprintf(submenue,"icon-wharf RESET ");
          system(submenue);
          exit(0);
          break;
        }
        if(ev.xbutton.button==4)
        {
          if (list_windows(disp,skip)!=EXIT_FAILURE)
          {
            if (get_active_window(disp)==0)
            {
              if (win_pid_list[0]!=0)  
                action_window(disp,win_pid_list[0],'a');
              break;  
            }  else  {
              act_win_pid=get_active_window(disp);
              for (i=0;i<500;i++)
              {
                if (win_pid_list[i]==act_win_pid)
                {
//                  printf("%d %d \n",win_count,i);
                  if (i<win_count-1)
                  {
                    if (win_pid_list[i+1]!=0)
                      action_window(disp,win_pid_list[i+1],'a');
                  } else  {
                    if (win_pid_list[0]!=0)
                      action_window(disp,win_pid_list[0],'a');
                  }    
                  break;  
                }
              }
            }
          }  
          break;
        }  
        if(ev.xbutton.button==5)
        {
          if (list_windows(disp,skip)!=EXIT_FAILURE)
          {
            if (get_active_window(disp)==0)
            {
              if (win_pid_list[0]!=0)  
                action_window(disp,win_pid_list[0],'a');
              break;  
            }  else  {
              act_win_pid=get_active_window(disp);
              for (i=0;i<500;i++)
              {
                if (win_pid_list[i]==act_win_pid)
                {
//                  printf("%d %d \n",win_count,i);
                  if (i>0) {
                    if (win_pid_list[i-1]!=0)
                      action_window(disp,win_pid_list[i-1],'a');
                  } else  {
                    if (win_pid_list[win_count-1]!=0)
                      action_window(disp,win_pid_list[win_count-1],'a');
                  }    
                  break;  
                }
              }
            }
          }  
          break;
        }  
      }
    } 
    while (XPending(disp));
    if (show_sys_inf==1)
    {
      imlib_context_set_blend(1);
      if(mytoggle == 1)
      {
        imlib_context_set_image(bigback);
        xl=x-24;
        yl=y-24;
      } else {
        imlib_context_set_image(back);
        xl=x-10;
        yl=y-10;
      }
    Imlib_Image        temp, temp2;
    temp = imlib_clone_image();
    imlib_context_set_image(temp);
    imlib_apply_filter
    ("bump_map_point(x=[],y=[],map=""blend.jpg);", &xl, &yl);
    imlib_context_set_image(back);
    imlib_render_image_on_drawable(0, 0);
    temp2 = im_bg;
    im_bg = temp;
    imlib_context_set_image(im_bg);
    imlib_context_set_blend(1);
    imlib_render_image_on_drawable(0, 0);
    im_bg = temp2;
    imlib_context_set_image(temp);
    imlib_free_image();
  }  else {
    Imlib_Image        temp, temp2;
    imlib_context_set_image(back);
    imlib_context_set_drawable(win);
    temp = imlib_clone_image();
    imlib_context_set_image(temp);
    imlib_apply_filter
    ("bump_map_point(x=[],y=[],map=""blend.jpg);", &xl, &yl);
    imlib_context_set_image(back);
    imlib_render_image_on_drawable(0, 0);
    temp2 = im_bg;
    im_bg = temp;
    imlib_context_set_image(im_bg);
    imlib_context_set_blend(1);
    imlib_render_image_on_drawable(0, 0);
    im_bg = temp2;
    imlib_context_set_image(temp);
    imlib_free_image();
    }    
  }  
  return 0;
}

