//g++ -o ./iconrun4 ./iconrun4.c -lX11 -lImlib2
//#include "config.h"
#include <X11/Xlib.h>
#include <X11/extensions/XShm.h>
#include <X11/Xutil.h>
#include <X11/extensions/shape.h>
#include <X11/Xatom.h>
#include <X11/Xos.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <math.h>

/*
#include <sys/time.h>
#include "common.h"
#include "image.h"
#include "rend.h"
#include "rgba.h"
#include "ximage.h"
#include "color.h"
 */
#include "Imlib2.h"

void exposelist(void);

Display            *disp;
Window              win;
Window              win2;
Visual             *vis;
Colormap            cm;
int                 depth;
XSetWindowAttributes attr;
char *appToRun;

int main(int argc, char **argv)
{
   int                 w, h;
   Imlib_Image        im_bg = NULL;
   XEvent              ev;
   const char         *display_name = getenv("DISPLAY");
   Imlib_Font          font;
   char                text[4096];
   Imlib_Image         buffer;
   Imlib_Image         back;
   Imlib_Image         bigback;
   Imlib_Color_Range   range;
   int hide=0;
   int  text_w, text_h;

   if (display_name == NULL)
       display_name = ":0";
   disp = XOpenDisplay(display_name);
   if (disp == NULL)
     {
       fprintf(stderr, "Can't open display %s\n", display_name);
       return 1;
     }
  char home[1024];
  sprintf(home,"%s",getenv("HOME"));

  int screen=DefaultScreen(disp);
  int screenWidth=0;
  screenWidth=XDisplayWidth(disp,screen);
  screenWidth=64;
  int screenHeight;
  screenHeight=64;
  int screenX=10;
  int screenY=10;
  char *picname;
  char *title;

//----arguments x y width height lower/raise(0/1) picture appToRun
  if ( argc != 8 ){
    printf("usage: iconrun4 x y width height image applicationToRun tag\n");
    return 1;
  }

  sscanf(argv[1], "%d", &screenX);
  sscanf(argv[2], "%d", &screenY);
  sscanf(argv[3], "%d", &screenWidth);
  sscanf(argv[4], "%d", &screenHeight);
  picname = argv[5];
  appToRun = argv[6];
  title = argv[7];

  vis = DefaultVisual(disp, DefaultScreen(disp));
  depth = DefaultDepth(disp, DefaultScreen(disp));
  cm = DefaultColormap(disp, DefaultScreen(disp));
  range = imlib_create_color_range();
  imlib_context_set_color_range(range);
  imlib_context_set_color(255, 255, 255, 255);
  imlib_add_color_to_color_range(0);
             /* add an orange color, semi-transparent 10 units from the first */
  imlib_context_set_color(255, 200, 10, 255);
  imlib_add_color_to_color_range(10);
             /* add black, fully transparent at the end 20 units away */
  imlib_context_set_color(70, 0, 0, 255);
  imlib_add_color_to_color_range(20);


  attr.override_redirect=True;
 
//win=XCreateWindow(disp,DefaultRootWindow(disp),screenX,screenY,screenWidth,screenHeight,0,CopyFromParent,InputOutput,CopyFromParent,CWBackingStore|CWOverrideRedirect|CWEventMask|CWBorderPixel|CWSaveUnder|CWColormap|CWBackPixel,&attr);
  win=XCreateWindow(disp,DefaultRootWindow(disp),screenX,screenY,screenWidth,screenHeight,0,0,0,CopyFromParent,CWBackingStore|CWOverrideRedirect|CWEventMask,&attr);


//   win =  XCreateSimpleWindow(disp, DefaultRootWindow(disp), 0, 0, 100, 100, 0, 0, 0);

  XSelectInput(disp, win, ButtonPressMask | ButtonReleaseMask | ButtonMotionMask | PointerMotionMask | ExposureMask | EnterWindowMask | LeaveWindowMask);

  XMapWindow(disp, win);
  XRaiseWindow(disp,win);

   /**
    * Start rendering
    */

  imlib_context_set_display(disp);
  imlib_context_set_visual(vis);
  imlib_context_set_colormap(cm);
  imlib_context_set_drawable(win);
  imlib_context_set_dither(1);
  imlib_context_set_blend(0);
  imlib_context_set_color_modifier(NULL);

//--
  w=screenWidth;
  h=screenHeight;
  char back_pic[1280];
  sprintf(back_pic,"%s/.icon-DE/pics/desk_icon_back.png",home);
  if (access(back_pic,0)==-1)
    sprintf(back_pic,"/usr/share/icon-DE/pics/desk_icon_back.png");
  back = imlib_load_image(back_pic);
  imlib_context_set_image(back);
  buffer = imlib_create_cropped_scaled_image(0, 0,imlib_image_get_width() ,imlib_image_get_height() , w , h);

  im_bg = imlib_load_image(picname);


  imlib_context_set_image(im_bg);
  int is=imlib_image_get_width();
  int ih=imlib_image_get_height();
  int d1=screenWidth-is;
  d1=d1/2;
  int d2=screenHeight-ih;
  d2=d2/2;


  imlib_context_set_image(im_bg);
  imlib_context_set_blend(1);

  imlib_context_set_image(back);
  imlib_render_image_on_drawable(0, 0);
  imlib_context_set_image(im_bg);
  imlib_render_image_on_drawable_at_size(d1-1, d2-1,is+2,ih+2);
  bigback=imlib_create_image_from_drawable( 0,0,0,w,h,1);

  imlib_context_set_image(back);
  imlib_render_image_on_drawable(0, 0);
  imlib_context_set_image(im_bg);

  imlib_render_image_on_drawable(d1, d2);
//  back=imlib_create_image_from_drawable( 0,0,0,w,h,1);
  char font_path[1024];
  sprintf(font_path,"%s/.icon-DE/fonts",home);
  imlib_add_path_to_font_path(font_path);
  imlib_add_path_to_font_path("/usr/share/fonts/truetype/wqy/");
  font = imlib_load_font("Vera/8");
  if (font == NULL)
    font = imlib_load_font("wqy-zenhei.ttc/8");
  imlib_context_set_font(font);
  imlib_context_set_color(0, 0, 0, 255);
  sprintf(text,"%s",title);
  imlib_get_text_size(text, &text_w, &text_h);
  buffer = imlib_create_image(text_w*2, text_h*2);  

  attr.override_redirect=True;
 
  win2=XCreateWindow(disp,win,0,0,text_w+10,text_h+4,0,0,0,CopyFromParent,CWBackingStore|CWOverrideRedirect|CWEventMask,&attr);
  XMapWindow(disp, win2);
//  XRaiseWindow(disp,win2);
  imlib_context_set_drawable(win2); 
   
  //           imlib_context_set_image(buffer);

             /* draw the range */
  imlib_context_set_image(buffer);
  imlib_image_fill_color_range_rectangle(0,0, text_w*4, text_h*2,
                                                   -45.0);
             /* free it */
        //     imlib_free_color_range();

  imlib_context_set_image(buffer);
  
  imlib_render_image_on_drawable(0, 0); 


  imlib_context_set_image(buffer);
  imlib_context_set_font(font);
  imlib_context_set_color(0, 0, 0, 255);
  imlib_text_draw(5,2,text);

             /* set the buffer image as our current image */
  imlib_context_set_image(buffer);

  imlib_context_set_drawable(win2); 
  imlib_render_image_on_drawable(0, 0); 


  imlib_context_set_image(buffer);
  imlib_free_image();
  imlib_context_set_font(font);
  imlib_free_font();

  imlib_context_set_image(im_bg);
  imlib_context_set_drawable(win);

  XResizeWindow(disp, win, w, h);
  XSync(disp, False);
  int xfd = ConnectionNumber(disp);
  fd_set rfds;
  long ticks;
  Atom prop;

  time_t now_time;
  struct timeval now, tm,LastTime,LastTime2;
  now_time=time(0);
  gettimeofday(&LastTime, 0);
  int s_ch=0;
  while (1)
  {
    if (XPending(disp))
    {
      XNextEvent(disp, &ev);
      switch (ev.type)
      {
      case Expose:
        s_ch=1;
        break;
      case MotionNotify:
        break;
      default:
        break;
      case EnterNotify:
        if (hide==1)
        {
          XMoveResizeWindow(disp, win, screenX, screenY, screenWidth, screenHeight);
          hide=0;
        }  
        break;
      case LeaveNotify:		
        break;
      case ButtonPress:				
        if(ev.xbutton.button==1)
        {
          exposelist();
        }
      }
    } else {
        //display 是由 XopenDisplay 返回的 Display *
      FD_ZERO(&rfds);
      FD_SET(xfd, &rfds);
      gettimeofday(&now, 0);
      if (s_ch==1)
      {
        w=screenWidth;
        h=screenHeight;
        imlib_context_set_image(back);
        buffer = imlib_create_cropped_scaled_image(0, 0,imlib_image_get_width() ,imlib_image_get_height() , w , h);

        im_bg = imlib_load_image(picname);


        imlib_context_set_image(im_bg);
        is=imlib_image_get_width();
        ih=imlib_image_get_height();
        d1=screenWidth-is;
        d1=d1/2;
        d2=screenHeight-ih;
        d2=d2/2;


        imlib_context_set_image(im_bg);
        imlib_context_set_blend(1);

        imlib_context_set_image(back);
        imlib_render_image_on_drawable(0, 0);
        imlib_context_set_image(im_bg);
        imlib_render_image_on_drawable_at_size(d1-1, d2-1,is+2,ih+2);
        bigback=imlib_create_image_from_drawable( 0,0,0,w,h,1);

        imlib_context_set_image(back);
        imlib_render_image_on_drawable(0, 0);
        imlib_context_set_image(im_bg);

        imlib_render_image_on_drawable(d1, d2);
//        back=imlib_create_image_from_drawable( 0,0,0,w,h,1);

        font = imlib_load_font("Vera/8");
        if (font == NULL)
          font = imlib_load_font("wqy-zenhei.ttc/8");
        imlib_context_set_font(font);
        imlib_context_set_color(0, 0, 0, 255);
        sprintf(text,"%s",title);
        imlib_get_text_size(text, &text_w, &text_h);
        buffer = imlib_create_image(text_w*2, text_h*2);        

        attr.override_redirect=True;
 
//        win2=XCreateWindow(disp,win,0,0,text_w+10,text_h+4,0,0,0,CopyFromParent,CWBackingStore|CWOverrideRedirect|CWEventMask,&attr);
//        XMapWindow(disp, win2);
//        XRaiseWindow(disp,win2);
        imlib_context_set_drawable(win2); 
         
        //                                   imlib_context_set_image(buffer);

                   /* draw the range */
        imlib_context_set_image(buffer);
        imlib_image_fill_color_range_rectangle(0,0, text_w*4, text_h*2,
                                                         -45.0);
             /* free it */
        //     imlib_free_color_range();

        imlib_context_set_image(buffer);
        
        imlib_render_image_on_drawable(0, 0); 


        imlib_context_set_image(buffer);
        imlib_context_set_font(font);
        imlib_context_set_color(0, 0, 0, 255);
        imlib_text_draw(5,2,text);

                         /* set the buffer image as our current image */
        imlib_context_set_image(buffer);

        imlib_context_set_drawable(win2); 
        imlib_render_image_on_drawable(0, 0); 


        imlib_context_set_image(buffer);
        imlib_free_image();
        imlib_context_set_font(font);
        imlib_free_font();

        imlib_context_set_image(im_bg);
        imlib_context_set_drawable(win);

//        XResizeWindow(disp, win, w, h);
        XRaiseWindow(disp,win);
        XSync(disp, False);
        s_ch=0;
      }

//LastTime 是 timeval 类型的变量,保存上次时间
//ticks 的单位是毫秒 millisecond
      ticks=(now.tv_sec-LastTime.tv_sec)*1000+(now.tv_usec-LastTime.tv_usec)/1000;
      if ((ticks>=10000) and (hide==0))
      {
        gettimeofday(&LastTime, 0);
        hide=1;
        XMoveResizeWindow(disp, win, 0, 0, 10, 10);
      }
//      ticks=(now.tv_sec-LastTime2.tv_sec)*1000+(now.tv_usec-LastTime2.tv_usec)/1000;
//      if (ticks>=1000*find_win_time)
//      {
//        if (list_windows(disp,skip)!=EXIT_FAILURE)
//        {
//          if (last_max_win_id!=max_win_id)
//          {
//            gettimeofday(&LastTime2, 0);
//            show_windows=30;
//            last_max_win_id=max_win_id;
//          }  
//        }
//      }
//如果到期则调用有关函数
//select 等待 100 毫秒
      tm.tv_sec=0l;
      tm.tv_usec=100000l;
      select(xfd + 1, &rfds, 0, 0, &tm);
    } /* End else*/
  }
  return 0;
}

void exposelist(void){
  //printf("exposelist\n");
  char app[2000];
  sprintf(app,"%s &",appToRun);
  system(app);
}
